#!/usr/bin/python3
# -*- coding: utf-8 -*-

# This script takes a badge template and fills it in with a
# CSV database.
#
# It is taken for granted the CSV database has columns with these names:
# Name, Line 2, Line 3, Languages, Diet
#
# The fields you want replaced in the SVG template also needs to be called:
# {Name}, {Line 2}, {Line 3}, {Languages} and {Diet}

import cairosvg  # you'll need python3-cairosvg

import argparse
import csv
import os
import re


# SVG path snippets for meal swatches
meat = '''
<path
     id="meat-rectangle"
     d="m 79.107559,46.702019 c -0.05167,0 -0.09354,0.04135 -0.09354,0.09302 V 60.61069 c 0,0.05167 0.04187,0.09354 0.09354,0.09354 h 19.628409 c 0.0517,0 0.093,-0.04187 0.093,-0.09354 V 46.79504 c 0,-0.05167 -0.0414,-0.09302 -0.093,-0.09302 z m 4.65724,2.049041 h 0.484225 l 3.857778,7.320735 H 87.622577 L 84.195278,49.57016 v 9.085028 h -0.430479 z m 0.974651,0 h 0.490426 l 3.852094,7.320735 h -0.490943 z m 0.975168,0 h 0.484225 l 3.612307,6.865967 3.60662,-6.865967 h 0.490426 v 9.904128 h -0.43048 V 49.57016 l -3.427296,6.501635 h -0.490426 z m 5.753334,0 h 0.490426 l -2.727058,5.149734 -0.251156,-0.454769 z m 0.980852,0 h 0.484741 l -3.206114,6.088727 -0.244955,-0.448567 z m 0.598433,2.194774 v 7.709354 H 92.616241 V 51.76545 Z m -8.421479,0.05375 0.430996,0.819616 v 6.835988 h -0.430996 z m 7.560004,1.579286 v 6.076318 H 91.755283 V 53.39228 Z m -6.698528,0.05995 0.430479,0.813415 v 5.20296 h -0.430479 z m 5.837569,1.590655 v 4.42572 h -0.430995 v -3.612306 z m -4.97661,0.04806 0.430996,0.813415 v 3.564244 h -0.430996 z"
     style="fill:#ff8000;fill-rule:evenodd;stroke-width:1" />'''

other = '''
  <path
     id="other-rectangle"
     d="M 79.01432,46.702257 V 60.70436 H 98.829201 V 46.702257 Z m 9.910748,1.619582 c 0.729739,0 1.425346,0.143381 2.08735,0.430461 0.665709,0.283112 1.238281,0.665709 1.71666,1.148321 0.482348,0.478379 0.865209,1.050951 1.148321,1.71666 0.28708,0.662004 0.430488,1.357611 0.430488,2.08735 0,0.72974 -0.143408,1.427463 -0.430488,2.093436 -0.283112,0.662005 -0.665973,1.233784 -1.148321,1.716131 -0.478379,0.478643 -1.050951,0.859653 -1.71666,1.142764 -0.662004,0.28708 -1.357611,0.430488 -2.08735,0.430488 -0.72974,0 -1.427463,-0.143408 -2.093436,-0.430488 -0.662005,-0.283111 -1.233784,-0.664121 -1.716131,-1.142764 -0.478644,-0.482347 -0.861241,-1.054126 -1.148321,-1.716131 -0.283111,-0.665973 -0.424931,-1.363696 -0.424931,-2.093436 0,-0.729739 0.14182,-1.425346 0.424931,-2.08735 0.28708,-0.665709 0.669677,-1.238281 1.148321,-1.71666 0.482347,-0.482612 1.054126,-0.865209 1.716131,-1.148321 0.665973,-0.28708 1.363696,-0.430461 2.093436,-0.430461 z m 0,0.430461 c -0.669942,0 -1.311573,0.13166 -1.925422,0.394821 -0.610144,0.259246 -1.136678,0.610092 -1.579338,1.052751 -0.442659,0.442395 -0.795092,0.970781 -1.05836,1.584894 -0.259298,0.610145 -0.389211,1.249923 -0.389211,1.919865 0,0.669942 0.129913,1.311838 0.389211,1.925951 0.263268,0.610144 0.615701,1.136149 1.05836,1.578808 0.44266,0.44266 0.969194,0.795093 1.579338,1.05836 0.613849,0.259034 1.25548,0.389212 1.925422,0.389212 0.669942,0 1.30972,-0.130178 1.919865,-0.389212 0.614113,-0.263267 1.142235,-0.6157 1.584894,-1.05836 0.442659,-0.442659 0.793505,-0.968664 1.052803,-1.578808 0.263003,-0.614113 0.394769,-1.256009 0.394769,-1.925951 0,-0.669942 -0.131766,-1.30972 -0.394769,-1.919865 C 93.223332,51.170653 92.872486,50.642267 92.429827,50.199872 91.987168,49.757213 91.459046,49.406367 90.844933,49.147121 90.234788,48.88396 89.59501,48.7523 88.925068,48.7523 Z m 0,0.430488 c 0.817318,0 1.573252,0.203735 2.267007,0.610409 0.694019,0.402706 1.241721,0.950937 1.644427,1.644692 0.406674,0.694019 0.610409,1.449424 0.610409,2.266742 0,0.817319 -0.203735,1.572723 -0.610409,2.266478 -0.402706,0.693755 -0.950408,1.243838 -1.644427,1.650777 -0.693755,0.402706 -1.449689,0.604059 -2.267007,0.604059 -0.817319,0 -1.572723,-0.201353 -2.266478,-0.604059 -0.693755,-0.406939 -1.244102,-0.957022 -1.650777,-1.650777 -0.402706,-0.693755 -0.604059,-1.449159 -0.604059,-2.266478 0,-0.817318 0.201353,-1.572723 0.604059,-2.266742 0.406675,-0.693755 0.957022,-1.241986 1.650777,-1.644692 0.693755,-0.406674 1.449159,-0.610409 2.266478,-0.610409 z m 0,0.431017 c -0.554316,0 -1.08429,0.107688 -1.590715,0.323065 -0.506426,0.215111 -0.942999,0.505896 -1.309986,0.872618 -0.362752,0.363017 -0.651685,0.797474 -0.867061,1.303899 -0.215376,0.506425 -0.323064,1.036928 -0.323064,1.591244 0,0.554316 0.107688,1.08429 0.323064,1.590715 0.215376,0.506161 0.504309,0.942999 0.867061,1.309985 0.366987,0.362753 0.80356,0.651686 1.309986,0.867062 0.506425,0.215376 1.036399,0.323064 1.590715,0.323064 0.554316,0 1.084819,-0.107688 1.591244,-0.323064 0.506425,-0.215376 0.940882,-0.504309 1.303635,-0.867062 0.366986,-0.366986 0.657771,-0.803824 0.872882,-1.309985 0.215376,-0.506425 0.323065,-1.036399 0.323065,-1.590715 0,-0.554316 -0.107689,-1.084819 -0.323065,-1.591244 -0.215111,-0.506425 -0.505896,-0.940882 -0.872882,-1.303899 -0.362753,-0.366722 -0.79721,-0.657507 -1.303635,-0.872618 -0.506425,-0.215377 -1.036928,-0.323065 -1.591244,-0.323065 z m 0,0.430488 c 0.662004,0 1.274,0.163517 1.83599,0.490286 0.562253,0.327033 1.007029,0.771809 1.334062,1.333798 0.326769,0.562253 0.490286,1.17425 0.490286,1.836254 0,0.66174 -0.163517,1.273737 -0.490286,1.83599 -0.327033,0.562254 -0.771809,1.00703 -1.334062,1.333799 -0.56199,0.327033 -1.173986,0.490549 -1.83599,0.490549 -0.662005,0 -1.274001,-0.163516 -1.83599,-0.490549 -0.562254,-0.326769 -1.00703,-0.771545 -1.333799,-1.333799 -0.327033,-0.562253 -0.490549,-1.17425 -0.490549,-1.83599 0,-0.662004 0.163516,-1.274001 0.490549,-1.836254 0.326769,-0.561989 0.771545,-1.006765 1.333799,-1.333798 0.561989,-0.326769 1.173985,-0.490286 1.83599,-0.490286 z m 0,0.430488 c -0.586067,0 -1.126095,0.145525 -1.620614,0.436574 -0.494519,0.28708 -0.88717,0.677615 -1.178219,1.172133 -0.287081,0.494519 -0.430488,1.035076 -0.430488,1.621143 0,0.586067 0.143407,1.126095 0.430488,1.620614 0.291049,0.494254 0.6837,0.88717 1.178219,1.178219 0.494519,0.28708 1.034547,0.431017 1.620614,0.431017 0.586066,0 1.126624,-0.143937 1.621143,-0.431017 0.494518,-0.291049 0.885053,-0.683965 1.172133,-1.178219 0.291049,-0.494519 0.436574,-1.034547 0.436574,-1.620614 0,-0.586067 -0.145525,-1.126624 -0.436574,-1.621143 -0.28708,-0.494518 -0.677615,-0.885053 -1.172133,-1.172133 -0.494519,-0.291049 -1.035077,-0.436574 -1.621143,-0.436574 z m 0,0.430488 c 0.378893,0 0.739793,0.07409 1.082702,0.221727 0.346877,0.147376 0.645864,0.346612 0.89696,0.597708 0.251361,0.251361 0.450597,0.550348 0.597973,0.897225 0.147642,0.342909 0.221727,0.703809 0.221727,1.082702 0,0.378629 -0.07408,0.741381 -0.221727,1.088259 -0.147376,0.342909 -0.346612,0.640308 -0.597973,0.891404 -0.251096,0.25136 -0.550083,0.450332 -0.89696,0.597973 -0.342909,0.147641 -0.703809,0.221197 -1.082702,0.221197 -0.378893,0 -0.741382,-0.07356 -1.088259,-0.221197 -0.342909,-0.147641 -0.640308,-0.346613 -0.891404,-0.597973 -0.25136,-0.251096 -0.450597,-0.548495 -0.597973,-0.891404 -0.147641,-0.346878 -0.221197,-0.70963 -0.221197,-1.088259 0,-0.378893 0.07356,-0.739793 0.221197,-1.082702 0.147376,-0.346877 0.346613,-0.645864 0.597973,-0.897225 0.251096,-0.251096 0.548495,-0.450332 0.891404,-0.597708 0.346877,-0.147642 0.709366,-0.221727 1.088259,-0.221727 z m 0,0.431017 c -0.653802,0 -1.211823,0.230987 -1.674326,0.693491 -0.462503,0.462503 -0.694019,1.020788 -0.694019,1.674854 0,0.653802 0.231516,1.211823 0.694019,1.674326 0.462503,0.462503 1.020524,0.694019 1.674326,0.694019 0.653802,0 1.212351,-0.231516 1.674854,-0.694019 0.462504,-0.462503 0.693491,-1.020524 0.693491,-1.674326 0,-0.654066 -0.230987,-1.212351 -0.693491,-1.674854 -0.462503,-0.462504 -1.021052,-0.693491 -1.674854,-0.693491 z"
     style="fill:#0063ff;fill-rule:evenodd;stroke-width:0.99999148" />'''

vegan = '''
<path
     id="vegan-rectangle"
     d="M 79.01432,46.702257 V 60.70436 H 98.829201 V 46.702257 Z m 4.410716,2.049541 h 0.466736 l 3.683887,9.324151 3.68468,-9.324151 0.460387,2.6e-5 -3.911434,9.904133 H 87.34282 l -3.917784,-9.904133 z m 0.927123,0 h 0.460386 l 3.062365,7.751164 -0.245275,0.550347 z m 0.927123,0 h 0.466472 l 2.589807,6.572945 -0.227547,0.592152 z m 0.927124,0 h 0.460386 l 2.123335,5.376469 -0.227283,0.604323 z m 5.974971,0 h 0.466472 l -3.917519,9.904133 h -0.460652 z m 0.93268,0 h 0.460915 l -3.917519,9.904133 h -0.460651 z m 0.921302,0 h 0.466208 l -3.916991,9.904133 h -0.460651 z"
     style="fill:#65b100;fill-rule:evenodd;stroke-width:0.99999148" />'''

vegetarian = '''
<path
     id="vegetarian-rectangle"
     d="M 79.01432,46.701888 V 60.70399 H 98.829201 V 46.701888 Z m 6.962951,1.674352 h 0.463032 v 10.652922 h -0.463032 z m 0.926065,0 h 0.463561 v 10.652922 h -0.463561 z m 0.926594,0 h 0.463032 V 59.029162 H 87.82993 Z m 0.926065,0 h 0.463562 v 8.337231 h 3.705318 v 0.463032 h -3.705318 v 0.463033 h 3.705318 v 0.463561 h -3.705318 v 0.463033 h 3.705318 v 0.463032 h -4.16888 z"
     style="fill:#ba005a;fill-rule:evenodd;stroke-width:0.99999148" />'''

meal_swatch = dict()
for i in ['meat', 'other', 'vegan', 'vegetarian']:
    meal_swatch["%s" % i] = eval(i)


def parse_cli():
    parser = argparse.ArgumentParser(description='''
    This script takes a badge template and fills it in with a CSV database.
    It is taken for granted the CSV database has columns in this order:
    Name, Line 2, Line 3, Languages, Diet''')
    parser.add_argument('-t', dest='template', help='Path to the SVG template')
    parser.add_argument('-d', dest='database', help='Path to the CSV database')
    parser.add_argument('-o', dest='output', default=os.getcwd(),
                    help='Path to the output directory')
    args = parser.parse_args()
    return args


def snake_case(string):
    s1 = re.sub('(.)([A-Z][a-z]+)', r'\1_\2', string)
    return re.sub('([a-z0-9])([A-Z])', r'\1_\2', s1).lower().replace(" ", "")


def create_badge(database, meal_swatch, template, output):
    with open(database) as csvfile:
        reader = csv.DictReader(csvfile)
        for row in reader:
            if not row['Diet']:  # meat diet defaults to an empty field
                row['Diet'] = 'meat'
            with open(template) as svgfile:
                output_path = os.path.join(output, snake_case(row['Name'] + '.png'))
                svg = svgfile.read()
                info = {'Name': row['Name'],
                        'Line 2': row['Line 2'],
                        'Line 3': row['Line 3'],
                        'Languages': row['Languages'],
                        'Diet': meal_swatch[row['Diet']]}
                badge = svg.format(**info)
                cairosvg.svg2png(bytestring=badge.encode('utf-8'),
                                 write_to=output_path,
                                 dpi=200)


def main():
    args = parse_cli()
    create_badge(args.database, meal_swatch, args.template, args.output)


if __name__ == "__main__":
    main()
